<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for reduction.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
reduction - reduction recognition

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>reduction</B> [ <I>options</I> ] <I>infile</I> <I>outfile</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <B>reduction</B> program recognizes program reductions and
puts annotations on the loops and SUIF instructions where
the reductions occur. This pass expects two file specifications
on the command line: first for the input file,
then for the output file.
<P>
Basically a reduction is an associative computation accumulated
to one location. The accumulated location is
called the reduction variable in this documentation. The
<B>reduction</B> program tries to recognize such reductions and
annotates the corresponding reduction variables and
enclosing FOR nodes. Later passes of the SUIF parallelizer
decide whether to do parallel reduction and which loop to
parallelize.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>


<DL>

<DT><B>-V</B> <I>n</I> </DT></DT>
<DD>This sets the the verbosity level to the integer <I>n</I>.
The default is verbosity level 0. At higher verbosity
levels, more comments will be written to
standard output about what <B>reduction</B> is doing.
Currently verbosity levels above one have the same
effect as level one.
</DD>

<DT><B>-debug</B> This </DT></DT>
<DD>tells <B>reduction</B> to dump debugging information
to the standard output.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>Scope</B> <B>of</B> <B>the</B> <B>Analysis</B></A></H2>

<P>
Currently four kinds of associative computations are supported,
namely, summation, multiplication, minimum, and
maximum. For each loop, <B>reduction</B> finds all read-modifywrite
operations to the same location and makes sure that
the modify operation is one of the four associative computations
mentioned above. It also guarantees that there are
no other non-reduction accesses to that location in that
loop or any inner loops. Other operands used in the
reduction operations are examined by the usual dependence
analysis.
<P>
A reduction variable can be a scalar variable or an array,
which is read and written in the same loop body. For example,
<B>s,</B> <B>a[i],</B> <B>b[i,3],</B> <B>c[d[i]]</B> can all be reduction variables.
That is, the <B>reduction</B> program recognizes reductions
in any direction.
<P>
The <B>reduction</B> pass puts reduction annotations on the
enclosing FOR nodes as long as the associative and readmodify-write
properties are preserved. It is up to the
later passes of the SUIF parallelizer to choose which loop
level to parallelize.
<P>
Multiple reductions are allowed. That is, the loop <I>j</I> in
the following example can be parallelized:
<P>
<B>for</B> <B>i</B><BR>

<B>for</B> <B>j</B><BR>

<B>A[j][3]</B> <B>=</B> <B>A[j][3]</B> <B>+</B> <B>...</B><BR>

<B>A[j][4]</B> <B>=</B> <B>A[j][4]</B> <B>+</B> <B>...</B><BR>

<B>B[j]</B> <B>=</B> <B>B[j]</B> <B>*</B> <B>...</B><BR>

<B>C[j]</B> <B>=</B> <B>max(C[j],</B> <B>...)</B><BR>

<B>D[j]</B> <B>=</B> <B>min(D[j],</B> <B>...)</B><BR>

<B>end</B> <B>j</B><BR>

<B>end</B> <B>i</B>
<P>
The <B>reduction</B> pass doesn't deal with read-modify-write
operations spanning multiple instruction AST nodes. Therefore,
a forward substitution pass must be run before this
pass to handle reductions across multiple instruction AST
nodes.

<H2><A NAME="sect5" HREF="#toc5"><B>See</B> <B>Also</B></A></H2>

<P>
<A HREF="man_skweel.1.html">skweel(1)</A>
, <A HREF="man_pgen.1.html">pgen(1)</A>
, <A HREF="man_oynk.1.html">oynk(1)</A>
, <A HREF="man_moo.1.html">moo(1)</A>


<H2><A NAME="sect6" HREF="#toc6"><B>History</B></A></H2>

<P>
Reduction was written by Shih-Wei Liao.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">Scope of the Analysis</A></LI>
<LI><A NAME="toc5" HREF="#sect5">See Also</A></LI>
<LI><A NAME="toc6" HREF="#sect6">History</A></LI>
</UL>
</BODY></HTML>
